diff --git a/common/xfs b/common/xfs
index c430b3ac..ade76d5a 100644
--- a/common/xfs
+++ b/common/xfs
@@ -1165,3 +1165,26 @@ _require_xfs_scratch_bigtime()
 		_notrun "bigtime feature not advertised on mount?"
 	_scratch_unmount
 }
+
+__xfs_cowgc_interval_knob1="/proc/sys/fs/xfs/speculative_cow_prealloc_lifetime"
+__xfs_cowgc_interval_knob2="/proc/sys/fs/xfs/speculative_prealloc_lifetime"
+
+_xfs_set_cowgc_interval() {
+	if [ -w $__xfs_cowgc_interval_knob1 ]; then
+		echo "$@" > $__xfs_cowgc_interval_knob1
+	elif [ -w $__xfs_cowgc_interval_knob2 ]; then
+		echo "$@" > $__xfs_cowgc_interval_knob2
+	else
+		_fail "Can't find cowgc interval procfs knob?"
+	fi
+}
+
+_xfs_get_cowgc_interval() {
+	if [ -w $__xfs_cowgc_interval_knob1 ]; then
+		cat $__xfs_cowgc_interval_knob1
+	elif [ -w $__xfs_cowgc_interval_knob2 ]; then
+		cat $__xfs_cowgc_interval_knob2
+	else
+		_fail "Can't find cowgc interval procfs knob?"
+	fi
+}
diff --git a/tests/xfs/231 b/tests/xfs/231
index 5930339d..119a71bb 100755
--- a/tests/xfs/231
+++ b/tests/xfs/231
@@ -22,9 +22,10 @@ trap "_cleanup; exit \$status" 0 1 2 3 15
 
 _cleanup()
 {
-    cd /
-    echo $old_cow_lifetime > /proc/sys/fs/xfs/speculative_cow_prealloc_lifetime
-    rm -rf $tmp.*
+	cd /
+	test -n "$old_cowgc_interval" && \
+		_xfs_set_cowgc_interval $old_cowgc_interval
+	rm -rf $tmp.*
 }
 
 # get standard environment, filters and checks
@@ -40,7 +41,7 @@ _require_xfs_io_command "cowextsize"
 _require_xfs_io_command "falloc"
 _require_xfs_io_command "fiemap"
 
-old_cow_lifetime=$(cat /proc/sys/fs/xfs/speculative_cow_prealloc_lifetime)
+old_cowgc_interval=$(_xfs_get_cowgc_interval)
 
 rm -f $seqres.full
 
@@ -74,7 +75,7 @@ md5sum $testdir/file2 | _filter_scratch
 md5sum $testdir/file2.chk | _filter_scratch
 
 echo "CoW and leave leftovers"
-echo 2 > /proc/sys/fs/xfs/speculative_cow_prealloc_lifetime
+_xfs_set_cowgc_interval 2
 seq 2 2 $((nr - 1)) | while read f; do
 	$XFS_IO_PROG -f -c "pwrite -S 0x63 $((blksz * f - 1)) 1" $testdir/file2 >> $seqres.full
 	$XFS_IO_PROG -f -c "pwrite -S 0x63 $((blksz * f - 1)) 1" $testdir/file2.chk >> $seqres.full
@@ -91,7 +92,7 @@ done
 $XFS_IO_PROG -f -c "falloc 0 $filesize" $testdir/junk >> $seqres.full
 
 echo "CoW and leave leftovers"
-echo $old_cow_lifetime > /proc/sys/fs/xfs/speculative_cow_prealloc_lifetime
+_xfs_set_cowgc_interval $old_cowgc_interval
 seq 2 2 $((nr - 1)) | while read f; do
 	$XFS_IO_PROG -f -c "pwrite -S 0x63 $((blksz * f)) 1" $testdir/file2 >> $seqres.full
 	$XFS_IO_PROG -f -c "pwrite -S 0x63 $((blksz * f)) 1" $testdir/file2.chk >> $seqres.full
diff --git a/tests/xfs/232 b/tests/xfs/232
index e56eb3aa..909f921c 100755
--- a/tests/xfs/232
+++ b/tests/xfs/232
@@ -23,9 +23,10 @@ trap "_cleanup; exit \$status" 0 1 2 3 15
 
 _cleanup()
 {
-    cd /
-    echo $old_cow_lifetime > /proc/sys/fs/xfs/speculative_cow_prealloc_lifetime
-    rm -rf $tmp.*
+	cd /
+	test -n "$old_cowgc_interval" && \
+		_xfs_set_cowgc_interval $old_cowgc_interval
+	rm -rf $tmp.*
 }
 
 # get standard environment, filters and checks
@@ -41,7 +42,7 @@ _require_cp_reflink
 _require_xfs_io_command "falloc"
 _require_xfs_io_command "fiemap"
 
-old_cow_lifetime=$(cat /proc/sys/fs/xfs/speculative_cow_prealloc_lifetime)
+old_cowgc_interval=$(_xfs_get_cowgc_interval)
 
 rm -f $seqres.full
 
@@ -75,7 +76,7 @@ md5sum $testdir/file2 | _filter_scratch
 md5sum $testdir/file2.chk | _filter_scratch
 
 echo "CoW and leave leftovers"
-echo 2 > /proc/sys/fs/xfs/speculative_cow_prealloc_lifetime
+_xfs_set_cowgc_interval 2
 seq 2 2 $((nr - 1)) | while read f; do
 	$XFS_IO_PROG -f -c "pwrite -S 0x63 $((blksz * f - 1)) 1" $testdir/file2 >> $seqres.full
 	$XFS_IO_PROG -f -c "pwrite -S 0x63 $((blksz * f - 1)) 1" $testdir/file2.chk >> $seqres.full
@@ -93,7 +94,7 @@ done
 $XFS_IO_PROG -f -c "falloc 0 $filesize" $testdir/junk >> $seqres.full
 
 echo "CoW and leave leftovers"
-echo $old_cow_lifetime > /proc/sys/fs/xfs/speculative_cow_prealloc_lifetime
+_xfs_set_cowgc_interval $old_cowgc_interval
 seq 2 2 $((nr - 1)) | while read f; do
 	$XFS_IO_PROG -f -c "pwrite -S 0x63 $((blksz * f)) 1" $testdir/file2 >> $seqres.full
 	$XFS_IO_PROG -f -c "pwrite -S 0x63 $((blksz * f)) 1" $testdir/file2.chk >> $seqres.full